package vtm_engine;

public class Instruction {
	
	private char state;
	private char read;
	private char write;
	private char nextState;
	private boolean moveRight;
	
	public Instruction(char state, char read, char write, char nextState, boolean moveRight) {
		this.state = state;
		this.read = read;
		this.write = write;
		this.nextState = nextState;
		this.moveRight = moveRight;
	}
	
	public Instruction(char state, char read, char write, char nextState, char moveRight) {
		this.state = state;
		this.read = read;
		this.write = write;
		this.nextState = nextState;
		if (moveRight == 'R' || moveRight == 'r') {
			this.moveRight = true;
		}
		else {
			this.moveRight = false;
		}
	}

	public boolean isMoveRight() {
		return moveRight;
	}

	public char getState() {
		return state;
	}

	public char getRead() {
		return read;
	}

	public char getWrite() {
		return write;
	}

	public char getNextState() {
		return nextState;
	}
	
	public String toString() {
		return "(" + state + " , " + read + " , " + write + " , " + nextState + " , " + moveRight + ")";
	}
	
	public void printInstruction() {
		System.out.println("(" + state + " , " + read + " , " + write + " , " + nextState + " , " + moveRight + ")");
	}
	
}
