package vtm_engine;

import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class VTM_GUI_INPUT extends JFrame {
	private static final long serialVersionUID = 1L;
	
	private static final int TEXT_FIELD_SIZE = 20;
	
	private JPanel inputPanel;
	private JPanel outputPanel;
	
	private JLabel InstructionTable_Label;
	private JLabel Tape_Label;
	private JLabel StartingState_Label;
	//private JLabel RWHead_Label;
	private JLabel ProgramName_Label;
	
	private JTextField InstructionTable_TextField;
	private JTextField Tape_TextField;
	private JTextField StartingState_TextField;
	//private JTextField RWHead_TextField;
	private JTextField ProgramName_TextField;
	
	private String InstructionTable_String;
	private String Tape_String;
	private String StartingState_String;
	//private String RWHead_String;
	private String ProgramName_String;
	
	private JButton runVTM_Button;
	
	private ActionListener runButton_Listener;
	
	private boolean run;

	public VTM_GUI_INPUT(String title) {
		super(title);
		setLayout(new FlowLayout());
		initComponents();
		run = false;
	} //Constructor
	
	private void initComponents() {
		inputPanel = new JPanel();
		inputPanel.setLayout(new GridLayout(5, 2));
		
		outputPanel = new JPanel();
		outputPanel.setLayout(new FlowLayout());
		
		InstructionTable_Label = new JLabel("Instruction Table");
		InstructionTable_Label.setToolTipText("Enter the Instruction Table file name in the text box please!");
		inputPanel.add(InstructionTable_Label);
		InstructionTable_TextField = new JTextField(TEXT_FIELD_SIZE);
		inputPanel.add(InstructionTable_TextField);
		
		Tape_Label = new JLabel("Tape");
		Tape_Label.setToolTipText("Enter the Tape file name in the text box please!");
		inputPanel.add(Tape_Label);
		Tape_TextField = new JTextField(TEXT_FIELD_SIZE);
		inputPanel.add(Tape_TextField);
		
		StartingState_Label = new JLabel("Starting State");
		StartingState_Label.setToolTipText("Enter the Starting State in the text box please!");
		inputPanel.add(StartingState_Label);
		StartingState_TextField = new JTextField(TEXT_FIELD_SIZE);
		inputPanel.add(StartingState_TextField);
		
		/**
		RWHead_Label = new JLabel("Read-Write Head");
		RWHead_Label.setToolTipText("Enter the initial value in the Read-Write Head in the text box please!");
		inputPanel.add(RWHead_Label);
		RWHead_TextField = new JTextField(TEXT_FIELD_SIZE);
		inputPanel.add(RWHead_TextField);
		*/
		
		ProgramName_Label = new JLabel("Program Name");
		ProgramName_Label.setToolTipText("Enter the Program Name in the text box please!");
		inputPanel.add(ProgramName_Label);
		ProgramName_TextField = new JTextField(TEXT_FIELD_SIZE);
		inputPanel.add(ProgramName_TextField);
		
		runVTM_Button = new JButton("Run VTM");
		outputPanel.add(runVTM_Button);
		runButton_Listener = new VTM_ActionListener();
		runVTM_Button.addActionListener(runButton_Listener);
		
		add(inputPanel);
		add(outputPanel);
	}
	
	public String getInstructionTable_String() {
		return InstructionTable_String;
	}

	public String getTape_String() {
		return Tape_String;
	}

	public String getStartingState_String() {
		return StartingState_String;
	}

	/**
	public String getRWHead_String() {
		return RWHead_String;
	}
	*/

	public String getProgramName_String() {
		return ProgramName_String;
	}
	
	public boolean isRunning() {
		return run;
	}

	private class VTM_ActionListener implements ActionListener {
		
		public void actionPerformed(ActionEvent event) {
			System.out.println("BUTTON PRESSED");
			
			InstructionTable_String = InstructionTable_TextField.getText();
			Tape_String = Tape_TextField.getText();
			StartingState_String = StartingState_TextField.getText();
			//RWHead_String = RWHead_TextField.getText();
			ProgramName_String = ProgramName_TextField.getText();
			
			run = true;
		}
	}
	
}
